Main Page | Modules | Data Structures | File List | Data Fields | Globals | Related Pages

# Obtaining advanced information about installed devices
[WinPcap tutorial: a step by step guide to using WinPcap]

Lesson 1 (Obtaining the device list) demonstrated how to get basic information (i.e. device name and description) about available adapters. Actually, WinPcap provides also other advanced information. In particular, every pcap_if structure returned by pcap_findalldevs_ex() contains also a list of pcap_addr structures, with:

- a list of addresses for that interface.
- a list of netmasks (each of which corresponds to an entry in the addresses list).
- a list of broadcast addresses (each of which corresponds to an entry in the addresses list).
- a list of destination addresses (each of which corresponds to an entry in the addresses list).

Additionally, pcap_findalldevs_ex() can also return remote adapters and a list of pcap files that are located in a given local folder.

The following sample provides an ifprint() function that prints the complete contents of a pcap_if structure. It is invoked by the program for every entry returned by pcap_findalldevs_ex().

    /*
     * Copyright (c) 1999 - 2003
     * NetGroup, Politecnico di Torino (Italy)
     * All rights reserved.
     *
     * Redistribution and use in source and binary forms, with or without
     * modification, are permitted provided that the following conditions
     * are met:
     *
     * 1. Redistributions of source code must retain the above copyright
     * notice, this list of conditions and the following disclaimer.
     * 2. Redistributions in binary form must reproduce the above copyright
     * notice, this list of conditions and the following disclaimer in the
     * documentation and/or other materials provided with the distribution.
     * 3. Neither the name of the Politecnico di Torino nor the names of its
     * contributors may be used to endorse or promote products derived from
     * this software without specific prior written permission.
     *
     * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
     * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
     * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
     * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
     * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
     * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
     * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
     * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
     * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
     * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
     * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
     *
     */

    #include "pcap.h"

    #ifndef WIN32
        #include <sys/socket.h>
        #include <netinet/in.h>
    #else
        #include <winsock.h>
    #endif

    // Function prototypes
    void ifprint(pcap_if_t *d);
    char *iptos(u_long in);
    char* ip6tos(struct sockaddr *sockaddr, char *address, int addrlen);

    int main()
    {
      pcap_if_t *alldevs;
      pcap_if_t *d;
      char errbuf[PCAP_ERRBUF_SIZE+1];
      char source[PCAP_ERRBUF_SIZE+1];

      printf("Enter the device you want to list:\n"
                "rpcap://              ==> lists interfaces in the local machine\n"
                "rpcap://hostname:port ==> lists interfaces in a remote machine\n"
                "                          (rpcapd daemon must be up and running\n"
                "                           and it must accept 'null' authentication)\n"
                "file://foldername     ==> lists all pcap files in the give folder\n\n"
                "Enter your choice: ");

      fgets(source, PCAP_ERRBUF_SIZE, stdin);
      source[PCAP_ERRBUF_SIZE] = '\0';

      /* Retrieve the interfaces list */
      if (pcap_findalldevs_ex(source, NULL, &alldevs, errbuf) == -1)
      {
        fprintf(stderr,"Error in pcap_findalldevs: %s\n",errbuf);
        exit(1);
      }

      /* Scan the list printing every entry */
      for(d=alldevs;d;d=d->next)
      {
        ifprint(d);
      }

      pcap_freealldevs(alldevs);

      return 1;
    }

    /* Print all the available information on the given interface */
    void ifprint(pcap_if_t *d)
    {
      pcap_addr_t *a;
      char ip6str[128];

      /* Name */
      printf("%s\n",d->name);

      /* Description */
      if (d->description)
        printf("\tDescription: %s\n",d->description);

      /* Loopback Address*/
      printf("\tLoopback: %s\n",(d->flags & PCAP_IF_LOOPBACK)?"yes":"no");

      /* IP addresses */
      for(a=d->addresses;a;a=a->next) {
        printf("\tAddress Family: #%d\n",a->addr->sa_family);

        switch(a->addr->sa_family)
        {
          case AF_INET:
            printf("\tAddress Family Name: AF_INET\n");
            if (a->addr)
              printf("\tAddress: %s\n",iptos(((struct sockaddr_in *)a->addr)->sin_addr.s_addr));
            if (a->netmask)
              printf("\tNetmask: %s\n",iptos(((struct sockaddr_in *)a->netmask)->sin_addr.s_addr));
            if (a->broadaddr)
              printf("\tBroadcast Address: %s\n",iptos(((struct sockaddr_in *)a->broadaddr)->sin_addr.s_addr));
            if (a->dstaddr)
              printf("\tDestination Address: %s\n",iptos(((struct sockaddr_in *)a->dstaddr)->sin_addr.s_addr));
            break;

          case AF_INET6:
            printf("\tAddress Family Name: AF_INET6\n");
            if (a->addr)
              printf("\tAddress: %s\n", ip6tos(a->addr, ip6str, sizeof(ip6str)));
           break;

          default:
            printf("\tAddress Family Name: Unknown\n");
            break;
        }
      }
      printf("\n");
    }

    /* From tcptraceroute, convert a numeric IP address to a string */
    #define IPTOSBUFFERS    12
    char *iptos(u_long in)
    {
        static char output[IPTOSBUFFERS][3*4+3+1];
        static short which;
        u_char *p;

        p = (u_char *)&in;
        which = (which + 1 == IPTOSBUFFERS ? 0 : which + 1);
        sprintf(output[which], "%d.%d.%d.%d", p[0], p[1], p[2], p[3]);
        return output[which];
    }

    char* ip6tos(struct sockaddr *sockaddr, char *address, int addrlen)
    {
        socklen_t sockaddrlen;

        #ifdef WIN32
        sockaddrlen = sizeof(struct sockaddr_in6);
        #else
        sockaddrlen = sizeof(struct sockaddr_storage);
        #endif

        if(getnameinfo(sockaddr,
            sockaddrlen,
            address,
            addrlen,
            NULL,
            0,
            NI_NUMERICHOST) != 0) address = NULL;

        return address;
    }

    00001 /*
    00002  * Copyright (c) 1999 - 2003
    00003  * NetGroup, Politecnico di Torino (Italy)
    00004  * All rights reserved.
    00005  *
    00006  * Redistribution and use in source and binary forms, with or without
    00007  * modification, are permitted provided that the following conditions
    00008  * are met:
    00009  *
    00010  * 1. Redistributions of source code must retain the above copyright
    00011  * notice, this list of conditions and the following disclaimer.
    00012  * 2. Redistributions in binary form must reproduce the above copyright
    00013  * notice, this list of conditions and the following disclaimer in the
    00014  * documentation and/or other materials provided with the distribution.
    00015  * 3. Neither the name of the Politecnico di Torino nor the names of its
    00016  * contributors may be used to endorse or promote products derived from
    00017  * this software without specific prior written permission.
    00018  *
    00019  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
    00020  * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
    00021  * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
    00022  * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
    00023  * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
    00024  * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
    00025  * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
    00026  * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
    00027  * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
    00028  * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
    00029  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
    00030  *
    00031  */
    00032
    00033
    00034 #include "pcap.h"
    00035
    00036 #ifndef WIN32
    00037     #include <sys/socket.h>
    00038     #include <netinet/in.h>
    00039 #else
    00040     #include <winsock.h>
    00041 #endif
    00042
    00043
    00044 // Function prototypes
    00045 void ifprint(pcap_if_t *d);
    00046 char *iptos(u_long in);
    00047 char* ip6tos(struct sockaddr *sockaddr, char *address, int addrlen);
    00048
    00049
    00050 int main()
    00051 {
    00052   pcap_if_t *alldevs;
    00053   pcap_if_t *d;
    00054   char errbuf[PCAP_ERRBUF_SIZE+1];
    00055   char source[PCAP_ERRBUF_SIZE+1];
    00056
    00057   printf("Enter the device you want to list:\n"
    00058             "rpcap://              ==> lists interfaces in the local machine\n"
    00059             "rpcap://hostname:port ==> lists interfaces in a remote machine\n"
    00060             "                          (rpcapd daemon must be up and running\n"
    00061             "                           and it must accept 'null' authentication)\n"
    00062             "file://foldername     ==> lists all pcap files in the give folder\n\n"
    00063             "Enter your choice: ");
    00064
    00065   fgets(source, PCAP_ERRBUF_SIZE, stdin);
    00066   source[PCAP_ERRBUF_SIZE] = '\0';
    00067
    00068   /* Retrieve the interfaces list */
    00069   if (pcap_findalldevs_ex(source, NULL, &alldevs, errbuf) == -1)
    00070   {
    00071     fprintf(stderr,"Error in pcap_findalldevs: %s\n",errbuf);
    00072     exit(1);
    00073   }
    00074
    00075   /* Scan the list printing every entry */
    00076   for(d=alldevs;d;d=d->next)
    00077   {
    00078     ifprint(d);
    00079   }
    00080
    00081   pcap_freealldevs(alldevs);
    00082
    00083   return 1;
    00084 }
    00085
    00086
    00087
    00088 /* Print all the available information on the given interface */
    00089 void ifprint(pcap_if_t *d)
    00090 {
    00091   pcap_addr_t *a;
    00092   char ip6str[128];
    00093
    00094   /* Name */
    00095   printf("%s\n",d->name);
    00096
    00097   /* Description */
    00098   if (d->description)
    00099     printf("\tDescription: %s\n",d->description);
    00100
    00101   /* Loopback Address*/
    00102   printf("\tLoopback: %s\n",(d->flags & PCAP_IF_LOOPBACK)?"yes":"no");
    00103
    00104   /* IP addresses */
    00105   for(a=d->addresses;a;a=a->next) {
    00106     printf("\tAddress Family: #%d\n",a->addr->sa_family);
    00107
    00108     switch(a->addr->sa_family)
    00109     {
    00110       case AF_INET:
    00111         printf("\tAddress Family Name: AF_INET\n");
    00112         if (a->addr)
    00113           printf("\tAddress: %s\n",iptos(((struct sockaddr_in *)a->addr)->sin_addr.s_addr));
    00114         if (a->netmask)
    00115           printf("\tNetmask: %s\n",iptos(((struct sockaddr_in *)a->netmask)->sin_addr.s_addr));
    00116         if (a->broadaddr)
    00117           printf("\tBroadcast Address: %s\n",iptos(((struct sockaddr_in *)a->broadaddr)->sin_addr.s_addr));
    00118         if (a->dstaddr)
    00119           printf("\tDestination Address: %s\n",iptos(((struct sockaddr_in *)a->dstaddr)->sin_addr.s_addr));
    00120         break;
    00121
    00122       case AF_INET6:
    00123         printf("\tAddress Family Name: AF_INET6\n");
    00124         if (a->addr)
    00125           printf("\tAddress: %s\n", ip6tos(a->addr, ip6str, sizeof(ip6str)));
    00126        break;
    00127
    00128       default:
    00129         printf("\tAddress Family Name: Unknown\n");
    00130         break;
    00131     }
    00132   }
    00133   printf("\n");
    00134 }
    00135
    00136
    00137
    00138 /* From tcptraceroute, convert a numeric IP address to a string */
    00139 #define IPTOSBUFFERS    12
    00140 char *iptos(u_long in)
    00141 {
    00142     static char output[IPTOSBUFFERS][3*4+3+1];
    00143     static short which;
    00144     u_char *p;
    00145
    00146     p = (u_char *)&in;
    00147     which = (which + 1 == IPTOSBUFFERS ? 0 : which + 1);
    00148     sprintf(output[which], "%d.%d.%d.%d", p[0], p[1], p[2], p[3]);
    00149     return output[which];
    00150 }
    00151
    00152 char* ip6tos(struct sockaddr *sockaddr, char *address, int addrlen)
    00153 {
    00154     socklen_t sockaddrlen;
    00155
    00156     #ifdef WIN32
    00157     sockaddrlen = sizeof(struct sockaddr_in6);
    00158     #else
    00159     sockaddrlen = sizeof(struct sockaddr_storage);
    00160     #endif
    00161
    00162
    00163     if(getnameinfo(sockaddr,
    00164         sockaddrlen,
    00165         address,
    00166         addrlen,
    00167         NULL,
    00168         0,
    00169         NI_NUMERICHOST) != 0) address = NULL;
    00170
    00171     return address;
    00172 }
    00173
    00174

<<< Previous Next >>>

documentation. Copyright (c) 2002-2005 Politecnico di Torino. Copyright (c) 2005 CACE technologies. All rights reserved.